﻿Imports Telerik.WinControls.UI

Public Class RadForm1
    Public Sub New()
        InitializeComponent()

        For i As Integer = 1 To 5
            Me.RadGridView1.Columns.Add("Misura " & i)
        Next

        Me.RadGridView1.SelectionMode = GridViewSelectionMode.FullRowSelect
    End Sub
End Class
Public Class CustomGrid
    Inherits RadGridView

    Protected Overrides Function CreateGridViewElement() As RadGridViewElement
        Return New CustomRadGridViewElement()
    End Function

    Public Overrides Property ThemeClassName As String
        Get
            Return GetType(RadGridView).FullName
        End Get
        Set(value As String)
            MyBase.ThemeClassName = value
        End Set
    End Property
End Class

Public Class CustomRadGridViewElement
    Inherits RadGridViewElement

    Protected Overrides Function CreateTemplate() As MasterGridViewTemplate
        Return New CustomMasterGridViewTemplate()
    End Function

    Protected Overrides ReadOnly Property ThemeEffectiveType As Type
        Get
            Return GetType(RadGridViewElement)
        End Get
    End Property
End Class

Public Class CustomMasterGridViewTemplate
    Inherits MasterGridViewTemplate

    Public Overrides Sub Paste()
        If Clipboard.ContainsData(DataFormats.Text) Then
            Dim data As String = Clipboard.GetData(DataFormats.Text).ToString()

            If data IsNot String.Empty AndAlso TypeOf Me.Owner.CurrentRow Is GridViewNewRowInfo Then
                Dim columnIndex As Integer = Me.Owner.CurrentColumn.Index
                Dim separator() As String = New String() {vbCrLf}
                Dim rowsInfo As String() = data.Split(separator, StringSplitOptions.RemoveEmptyEntries)

                For Each rowInfo As String In rowsInfo
                    Dim separator2() As String = New String() {vbTab}
                    Dim cellsInfo As String() = rowInfo.Split(separator2, StringSplitOptions.RemoveEmptyEntries)
                    Dim rowToInsert As GridViewRowInfo = Me.Owner.Rows.NewRow()

                    For i As Integer = 0 To cellsInfo.Length - 1
                        rowToInsert.Cells(i + columnIndex).Value = cellsInfo(i)
                    Next

                    Me.Owner.Rows.Add(rowToInsert)
                Next
            End If
        End If
    End Sub
End Class